' ========================================================================================
' GdipCreateBitmapFromResource
' ========================================================================================

' SED_PBWIN
#COMPILE EXE
#DIM ALL
#INCLUDE "GDIPLUS.INC"
#RESOURCE "EX_GdipCreateBitmapFromResource_01.pbr"

' ========================================================================================
' The following example creates a Bitmap based on an application instance handle and the
' name of a bitmap resource.
' ========================================================================================
SUB GDIP_BmpFromResource (BYVAL hdc AS DWORD)

   LOCAL hStatus AS LONG
   LOCAL hInstance AS DWORD
   LOCAL pGraphics AS DWORD
   LOCAL pBitmap AS DWORD
   LOCAL strName AS STRING

   hInstance = GetModuleHandle(BYVAL %NULL)
   hStatus = GdipCreateFromHDC(hdc, pGraphics)

   '  // Create a Bitmap object from a resource
   strName = UCODE$("BitmapResource1")
   hStatus = GdipCreateBitmapFromResource(hInstance, STRPTR(strName), pBitmap)

   ' // Draw the bitmap
   hStatus = GdipDrawImageI(pGraphics, pBitmap, 10, 10)

   ' // Cleanup
   IF pBitmap THEN GdipDisposeImage(pBitmap)
   IF pGraphics THEN GdipDeleteGraphics(pGraphics)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

   LOCAL hr AS LONG
   LOCAL hDlg AS DWORD
   LOCAL token AS DWORD
   LOCAL StartupInput AS GdiplusStartupInput

   ' Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hr = GdiplusStartup(token, StartupInput, BYVAL %NULL)
   IF hr THEN
      MSGBOX "Error initializing GDI+"
      EXIT FUNCTION
   END IF

   DIALOG NEW 0, "GdipCreateBitmapFromResource", , , 270, 170, %WS_OVERLAPPED OR %WS_THICKFRAME OR %WS_SYSMENU OR _
   %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX OR %WS_VISIBLE OR %DS_CENTER TO hDlg
   DIALOG SET COLOR hDlg, %BLACK, %WHITE
   DIALOG SHOW MODAL hDlg, CALL DlgProc

   ' Shutdown GDI+
   GdiplusShutdown token

END FUNCTION
' ========================================================================================

' ========================================================================================
' Main Dialog procedure
' ========================================================================================
CALLBACK FUNCTION DlgProc() AS LONG

   LOCAL hDC AS DWORD
   LOCAL ps AS PAINTSTRUCT

   SELECT CASE CBMSG

      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDCANCEL
               IF CBCTLMSG = %BN_CLICKED THEN DIALOG END CBHNDL, 0
         END SELECT

      CASE %WM_PAINT
         hDC = BeginPaint(CBHNDL, ps)
         GDIP_BmpFromResource hDC
         EndPaint(CBHNDL, ps)

   END SELECT

END FUNCTION
' ========================================================================================
