' ========================================================================================
' GdipCreateBitmapFromResource
' ========================================================================================

' SED_PBWIN
#COMPILE EXE
#DIM ALL
#INCLUDE "GDIPLUS.INC"
#RESOURCE "EX_GdipCreateBitmapFromResource_01.pbr"

%IDC_GRAPHIC = 101

' ========================================================================================
' The following example creates a Bitmap based on an application instance handle and the
' name of a bitmap resource.
' ========================================================================================
SUB GDIP_BmpFromResource (BYVAL hdc AS DWORD)

   LOCAL hStatus AS LONG
   LOCAL hInstance AS DWORD
   LOCAL pGraphics AS DWORD
   LOCAL pBitmap AS DWORD
   LOCAL strName AS STRING

   hInstance = GetModuleHandle(BYVAL %NULL)
   hStatus = GdipCreateFromHDC(hdc, pGraphics)

   '  // Create a Bitmap object from a resource
   strName = UCODE$("BitmapResource1")
   hStatus = GdipCreateBitmapFromResource(hInstance, STRPTR(strName), pBitmap)

   ' // Draw the bitmap
   hStatus = GdipDrawImageI(pGraphics, pBitmap, 10, 10)

   ' // Cleanup
   IF pBitmap THEN GdipDisposeImage(pBitmap)
   IF pGraphics THEN GdipDeleteGraphics(pGraphics)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

   LOCAL hr AS LONG
   LOCAL hdc AS DWORD
   LOCAL hDlg AS DWORD
   LOCAL token AS DWORD
   LOCAL StartupInput AS GdiplusStartupInput

   ' Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hr = GdiplusStartup(token, StartupInput, BYVAL %NULL)
   IF hr THEN
      MSGBOX "Error initializing GDI+"
      EXIT FUNCTION
   END IF

   ' Create a new dialog
   DIALOG NEW PIXELS, 0, "GdipCreateBitmapFromResource", , , 400, 250, %WS_SYSMENU TO hDlg

   ' Add a graphic control
   CONTROL ADD GRAPHIC, hDlg, %IDC_GRAPHIC,"", 0, 0, 400, 250
   ' Select the drawing target
   GRAPHIC ATTACH hDlg, %IDC_GRAPHIC
   ' Set the foreground and background color
   GRAPHIC COLOR %BLACK, %WHITE
   ' Clear the entire selected graphic window
   GRAPHIC CLEAR
   ' Retrieve the handle of the device context
   GRAPHIC GET DC TO hdc
   ' Draw the graphics
   GDIP_BmpFromResource hdc

   DIALOG SHOW MODAL hDlg, CALL DlgProc

   ' Shutdown GDI+
   GdiplusShutdown token

END FUNCTION
' ========================================================================================

' ========================================================================================
' Main Dialog procedure
' ========================================================================================
CALLBACK FUNCTION DlgProc() AS LONG

   SELECT CASE CBMSG

      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDCANCEL
               IF CBCTLMSG = %BN_CLICKED THEN DIALOG END CBHNDL, 0
         END SELECT

   END SELECT

END FUNCTION
' ========================================================================================
